/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2007-2011 by TAKAGI Nobuhisa
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */
#define __STDC_CONSTANT_MACROS  1
#include "cfg.hpp"
#include <ctime>
#include <sys/types.h>
#include <sys/stat.h>

//! cfgΥС
extern char const cfg_version[] = "1.7.0";

/*!
 *  \brief  ץե(cfg or cfg.exe)Υॹפ롣
 *  \return ॹפ64ӥåͤȤ֤
 *
 *  ֵͤη
 *
 *  YYYYMMDDhhmmss
 *
 *  Ȥʤ롣YYYYǯMMϷDDhhϻmmʬss
 *
 *  \note   ե̾ main ΰ argv[0] ȤäƤ롣PATH ϸʤΤ!
 *  \note   δؿ stat ؿ˰¸Ƥ뤿꤬ܿ롣
 */
std::tr1::int64_t cfg_timestamp()
{
  std::tr1::int64_t result;

  try
  {
    std::string program_name = toppers::get_global< std::string >( "argv0" );

    struct stat sb;
    stat( program_name.c_str(), &sb );
    struct tm t = *localtime( &sb.st_mtime );
    result = ( t.tm_year + 1900 ) * INT64_C( 10000000000 ) + ( t.tm_mon + 1 ) * INT64_C( 100000000 ) + t.tm_mday * 1000000
      + t.tm_hour * 10000 + t.tm_min * 100 + t.tm_sec;
  }
  catch ( ... )
  {
    result = -1;
  }
  return result;
}
